;;;; levenshtein-cost-fixnum.scm -*- Scheme -*-
;;;; Kon Lovett, Mar '20
;;;; Kon Lovett, Apr '12
;;;; Kon Lovett, May '06

(include "levenshtein-cost-interface")

(module levenshtein-cost-fixnum COST-OPER

(import scheme)
(import (chicken base))
(import (chicken type))
(import (chicken fixnum))

(define-type cost fixnum)

(: cost-multiply (cost cost -> cost))
(: cost-add (cost cost -> cost))
(: cost-minimum (cost #!rest cost -> cost))
(: cost-less-than (cost cost -> boolean))
(define-type cost-positive-infinity cost)

(define cost-add fx+)
(define cost-multiply fx*)
(define cost-minimum fxmin)
(define cost-less-than fx<)
(define cost-positive-infinity most-positive-fixnum)

) ;module levenshtein-cost-fixnum
